LineNumberTable (jakarta-bcel 5.2 API)
Keywords: org.apache.bcel.classfile.LineNumberTable class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.bcel.classfile
Class LineNumberTable

    java.lang.Object
      org.apache.bcel.classfile.Attribute
          org.apache.bcel.classfile.LineNumberTable

All Implemented Interfaces:
  Serializable, Cloneable, Node

    public final class LineNumberTable

extends Attribute

This class represents a table of line numbers for debugging purposes. This attribute is used by the Code attribute. It contains pairs of PCs and line numbers.

Version:
  $Id: LineNumberTable.java 386056 2006-03-15 11:31:56Z tcurdt $
See Also:
  `Code`, `LineNumber`, Serialized Form

Field Summary

Fields inherited from class org.apache.bcel.classfile.Attribute
`constant_pool, length, name_index, tag`

Constructor Summary
`LineNumberTable(int name_index, int length, LineNumber[] line_number_table, ConstantPool constant_pool)`
`LineNumberTable(LineNumberTable c)`

Method Summary
`void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
`Attribute` | `copy(ConstantPool _constant_pool)`
`void` | `dump(DataOutputStream file)` Dump line number table attribute to file stream in binary format.
`LineNumber[]` | `getLineNumberTable()`
`int` | `getSourceLine(int pos)` Map byte code positions to source code lines.
`int` | `getTableLength()`
`void` | `setLineNumberTable(LineNumber[] line_number_table)`
`String` | `toString()`

Methods inherited from class org.apache.bcel.classfile.Attribute
`addAttributeReader, clone, getConstantPool, getLength, getNameIndex, getTag, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LineNumberTable

    public LineNumberTable(LineNumberTable c)

### LineNumberTable

    public LineNumberTable(int name_index,
                           int length,
                           LineNumber[] line_number_table,
                           ConstantPool constant_pool)

Method Detail

### accept

    public void accept(Visitor v)

  Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.

  Specified by:
    `accept` in interface `Node`
  Specified by:
    `accept` in class `Attribute`
  Parameters:
    `v` - Visitor object

### dump

    public final void dump(DataOutputStream file)
                    throws IOException

  Dump line number table attribute to file stream in binary format.

  Overrides:
    `dump` in class `Attribute`
  Parameters:
    `file` - Output file stream
  Throws:
    `IOException`

### getLineNumberTable

    public final LineNumber[] getLineNumberTable()

  Returns:
    Array of (pc offset, line number) pairs.

### setLineNumberTable

    public final void setLineNumberTable(LineNumber[] line_number_table)

  Parameters:
    `line_number_table` - the line number entries for this table

### toString

    public final String toString()

  Overrides:
    `toString` in class `Attribute`
  Returns:
    String representation.

### getSourceLine

    public int getSourceLine(int pos)

  Map byte code positions to source code lines.

  Parameters:
    `pos` - byte code offset
  Returns:
    corresponding line in source code

### copy

    public Attribute copy(ConstantPool _constant_pool)

  Specified by:
    `copy` in class `Attribute`
  Returns:
    deep copy of this attribute

### getTableLength

    public final int getTableLength()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2006 Apache Software Foundation. All Rights Reserved.